Compare commits

..

23 Commits

Author SHA1 Message Date
mudler 67781838d3 [builder/sabayon-buildpackages] safe copy /usr/local/portage 2016-04-21 22:01:22 +02:00
mudler 69d8e28ac1 [builder] fixing permissions on local overlay 2016-04-21 21:52:41 +02:00
mudler b491ffccae [builder] check if the content is already there before appending content to file 2016-04-21 21:30:09 +02:00
mudler 066fb07d72 [builder] typo fixes 2016-04-17 19:47:01 +02:00
mudler c89721ab2e [builder] dropping equo (un)mask call, writing directly to packages.(un)mask files 2016-04-16 16:20:28 +02:00
mudler ea3d87a48a [sabayon-createrepo-*] adding gpg key support 2016-04-14 23:28:25 +02:00
mudler d1481e915f [builder] equo (s)mask should be done before installing any packages 2016-04-13 16:08:36 +02:00
mudler b185a1536b [sabayon-buildpackages] typo fix 2016-04-11 21:35:19 +02:00
mudler b089771d17 [builder/sabayon-buildpackages] adding support for equo (un)mask 2016-04-11 21:27:33 +02:00
mudler f81e90d555 [builder] don't exit if no args are given, allowing creating up-to-dated container with all set-up for compilation also if no args are given. adding --help 2016-04-08 19:20:20 +02:00
mudler fb930cdeb3 [builder] add support for BUILD_INJECTED_ARGS 2016-04-08 19:09:06 +02:00
mudler a904bbcbe1 [sabayon-createrepo] adding information output of repo creation phases 2016-04-08 00:51:08 +02:00
mudler ccd4a760f4 [sabayon-createrepo] fixing eit key signing 2016-04-08 00:47:59 +02:00
mudler 0944d27ce9 [sabayon-createrepo] fixing typo 2016-04-08 00:17:42 +02:00
mudler d248206aaa [sabayon-createrepo] push after repository initialization 2016-04-07 22:11:55 +02:00
mudler 65c62a3d8a [sabayon-*] executables 2016-04-07 21:06:13 +02:00
mudler 3be8ff13d1 [sabayon-help-info] adding script to collect system information to allow easy sharing for assistance 2016-04-07 21:05:59 +02:00
mudler 99cae9c7d1 [sabayon-createrepo] don't import keys if already exists 2016-04-07 16:09:09 +02:00
mudler d0df62c8f6 [sabayon-createrepo] signing old packages before injecting new ones 2016-04-06 21:48:28 +02:00
mudler 6ee7ef7845 [builder] show in logs the devkit version 2016-03-29 19:07:48 +02:00
mudler b212b4ce8b [sabayon-buildpackages builder] support for REPOSITORY_NAME and ENMAN_ADD_SELF 2016-03-29 18:58:46 +02:00
mudler c7fce5fd62 [builder] adding revdep-rebuild in preserved_rebuild phase. if an user enables it, it is sane to call also revdep-rebuild 2016-03-29 18:23:20 +02:00
mudler 330eb6faef [builder] adding notes on why we do safe_call during equo install phases 2016-03-29 12:18:07 +02:00
9 changed files with 95 additions and 17 deletions
+66 -12
View File
@@ -26,21 +26,24 @@ my $emerge_split_install = $ENV{EMERGE_SPLIT_INSTALL} // 0;
my $webrsync = $ENV{WEBRSYNC} // 0; my $webrsync = $ENV{WEBRSYNC} // 0;
my $enman_repositories = $ENV{ENMAN_REPOSITORIES}; my $enman_repositories = $ENV{ENMAN_REPOSITORIES};
my $prune_virtuals = $ENV{PRUNE_VIRTUALS} // 0; my $prune_virtuals = $ENV{PRUNE_VIRTUALS} // 0;
my $repository_name = $ENV{REPOSITORY_NAME};
my $enman_add_self = $ENV{ENMAN_ADD_SELF} // 1;
my $build_injected_args = $ENV{BUILD_INJECTED_ARGS};
my $equo_masks = $ENV{EQUO_MASKS};
my $equo_unmasks = $ENV{EQUO_UNMASKS};
my $make_conf = $ENV{MAKE_CONF}; my $make_conf = $ENV{MAKE_CONF};
my @overlays; my @overlays;
my $help = 0;
GetOptions( GetOptions(
'layman|overlay:s{,}' => \@overlays, 'layman|overlay:s{,}' => \@overlays,
'equo|install:s{,}' => \@equo_install, 'equo|install:s{,}' => \@equo_install,
'equorm|remove:s{,}' => \@equo_remove 'equorm|remove:s{,}' => \@equo_remove,
'help|?' => \$help
); );
if ( @ARGV == 0 ) { help() if $help;
help();
die();
}
$ENV{LC_ALL} = "en_US.UTF-8"; #here be dragons $ENV{LC_ALL} = "en_US.UTF-8"; #here be dragons
@@ -54,6 +57,22 @@ sub safe_call {
exit($return) if ($rt); exit($return) if ($rt);
} }
sub append_to_file {
my ( $file_name, $package ) = @_;
# Check that the package was not already there
open my $fh_ro, '<:encoding(UTF-8)', $file_name or die;
while ( my $line = <$fh_ro> ) {
return if $line eq $package . "\n";
}
close $fh_ro;
open( my $fh_a, '>>', $file_name )
or die "Could not open file '$filename' $!";
print $fh_a $package . "\n";
close $fh_a;
}
# Input: package, depth, and atom. Package: sys-fs/foobarfs, Depth: 1 (depth of the package tree) , Atom: 1/0 (enable disable atom output) # Input: package, depth, and atom. Package: sys-fs/foobarfs, Depth: 1 (depth of the package tree) , Atom: 1/0 (enable disable atom output)
sub package_deps { sub package_deps {
my $package = shift; my $package = shift;
@@ -159,6 +178,7 @@ sub help {
"You can supply multiple overlays as well: $0 plasma-meta --layman kde plab", "You can supply multiple overlays as well: $0 plasma-meta --layman kde plab",
"The documentation is available at https://github.com/Sabayon/devkit", "The documentation is available at https://github.com/Sabayon/devkit",
""; "";
exit 0;
} }
say "****************************************************"; say "****************************************************";
@@ -178,11 +198,11 @@ say "[*] Syncing configurations files, Layman and Portage";
# Syncronizing portage configuration and adding overlays # Syncronizing portage configuration and adding overlays
system("echo 'en_US.UTF-8 UTF-8' > /etc/locale.gen"); #be sure about that. system("echo 'en_US.UTF-8 UTF-8' > /etc/locale.gen"); #be sure about that.
system( "cd /etc/portage/;git checkout master; git stash; git pull" ); system("cd /etc/portage/;git checkout master; git stash; git pull");
if ( `uname -m` eq "x86_64\n" ) { if ( `uname -m` eq "x86_64\n" ) {
system( system(
"cd /etc/portage/;rm -rfv make.conf;ln -s make.conf.amd64 make.conf" ); "cd /etc/portage/;rm -rfv make.conf;ln -s make.conf.amd64 make.conf");
} }
system("echo 'y' | layman -f -a $_") for @overlays; system("echo 'y' | layman -f -a $_") for @overlays;
@@ -190,11 +210,14 @@ system("echo 'y' | layman -f -a $_") for @overlays;
my $reponame = "LocalOverlay"; my $reponame = "LocalOverlay";
# Setting up a local overlay if doesn't exists # Setting up a local overlay if doesn't exists
system(
"rm -rf /usr/local/portage;cp -rf /usr/local/local_portage /usr/local/portage"
);
if ( !-f "/usr/local/portage/profiles/repo_name" ) { if ( !-f "/usr/local/portage/profiles/repo_name" ) {
system("mkdir -p /usr/local/portage/{metadata,profiles}"); system("mkdir -p /usr/local/portage/{metadata,profiles}");
system("echo 'LocalOverlay' > /usr/local/portage/profiles/repo_name"); system("echo 'LocalOverlay' > /usr/local/portage/profiles/repo_name");
system("echo 'masters = gentoo' > /usr/local/portage/metadata/layout.conf"); system("echo 'masters = gentoo' > /usr/local/portage/metadata/layout.conf");
system("chown -R portage:portage /usr/local/portage");
} }
else { else {
open FILE, "</usr/local/portage/profiles/repo_name"; open FILE, "</usr/local/portage/profiles/repo_name";
@@ -203,6 +226,8 @@ else {
chomp(@FILE); chomp(@FILE);
$reponame = $FILE[0]; $reponame = $FILE[0];
} }
system("chown -R portage:portage /usr/local/portage");
system("chmod -R 755 /usr/local/portage");
qx{ qx{
echo '[$reponame] echo '[$reponame]
@@ -244,8 +269,11 @@ elsif ( $use_equo && $entropy_repository eq "testing" ) {
if ($use_equo) { if ($use_equo) {
if ( $enman_repositories and $enman_repositories ne "" ) { if ( $enman_repositories and $enman_repositories ne "" ) {
my @enman_toadd = split( / /, $enman_repositories ); my @enman_toadd = split( / /, $enman_repositories );
system("enman add $_") for @enman_toadd; safe_call("enman add $_") for @enman_toadd;
} }
system("enman add $repository_name")
if ( $enman_add_self and $repository_name and $repository_name ne "" );
system("equo repo mirrorsort sabayonlinux.org") if $equo_mirrorsort; system("equo repo mirrorsort sabayonlinux.org") if $equo_mirrorsort;
system("equo up && equo u"); system("equo up && equo u");
} }
@@ -257,6 +285,19 @@ qx|echo 'ACCEPT_LICENSE="*"' >> /etc/portage/make.conf|; #just plain evil
my @packages = @ARGV; my @packages = @ARGV;
if ($use_equo) { if ($use_equo) {
# best effort mask
if ($equo_masks) {
append_to_file( "/etc/entropy/packages/package.mask", $_ )
for ( split( / /, $equo_masks ) );
}
# best effort unmask
if ($equo_unmasks) {
append_to_file( "/etc/entropy/packages/package.unmask", $_ )
for ( split( / /, $equo_unmasks ) );
}
my @packages_deps; my @packages_deps;
my @Installed_Packages = qx/equo q list installed --quiet/; my @Installed_Packages = qx/equo q list installed --quiet/;
my @Available_Packages = available_packages(); my @Available_Packages = available_packages();
@@ -286,14 +327,17 @@ if ($use_equo) {
say "", "[install] Those dependencies will be installed with equo :", say "", "[install] Those dependencies will be installed with equo :",
@packages_deps, ""; @packages_deps, "";
if ($equo_split_install) { if ($equo_split_install) {
safe_call("equo i --bdeps $_") for ( @packages_deps, @equo_install ); safe_call("equo i --bdeps $_")
for ( @packages_deps, @equo_install )
; ## bail out here, if installs fails. emerge will compile a LOT of stuff
if ( @equo_remove > 0 ) { if ( @equo_remove > 0 ) {
system("equo rm --nodeps $_") for (@equo_remove); system("equo rm --nodeps $_") for (@equo_remove);
} }
} }
else { else {
safe_call("equo i --bdeps @packages_deps @equo_install") safe_call("equo i --bdeps @packages_deps @equo_install")
if ( @packages_deps > 0 or @equo_install > 0 ); if ( @packages_deps > 0 or @equo_install > 0 )
; ## bail out here, if installs fails. emerge will compile a LOT of stuff
system("equo rm --nodeps @equo_remove") if ( @equo_remove > 0 ); system("equo rm --nodeps @equo_remove") if ( @equo_remove > 0 );
} }
} }
@@ -303,6 +347,9 @@ say "*** Ready to compile, finger crossed ***";
system("emerge --info") system("emerge --info")
; #always give detailed information about the building environment, helpful to debug ; #always give detailed information about the building environment, helpful to debug
say "Devkit version:";
system("equo s -vq app-misc/sabayon-devkit");
my $rt; my $rt;
if ($emerge_split_install) { if ($emerge_split_install) {
@@ -319,9 +366,16 @@ else {
my $return = $rt >> 8; my $return = $rt >> 8;
# best effort -B
if ($build_injected_args) {
system("emerge $emerge_defaults_args -j $jobs -B $_")
for ( split( / /, $build_injected_args ) );
}
if ($preserved_rebuild) { if ($preserved_rebuild) {
system("emerge -j $jobs --buildpkg \@preserved-rebuild"); system("emerge -j $jobs --buildpkg \@preserved-rebuild");
system("revdep-rebuild");
} }
+5 -1
View File
@@ -44,6 +44,10 @@ docker_volumes=( -v "$OUTPUT_DIR:/usr/portage/packages" )
[ -z "$ENTROPY_DOWNLOADED_PACKAGES" ] || docker_volumes+=(-v "$ENTROPY_DOWNLOADED_PACKAGES:/var/lib/entropy/client/packages") [ -z "$ENTROPY_DOWNLOADED_PACKAGES" ] || docker_volumes+=(-v "$ENTROPY_DOWNLOADED_PACKAGES:/var/lib/entropy/client/packages")
[ -z "$DISTCC_HOSTS" ] || docker_env+=(-e "DISTCC_HOSTS=$DISTCC_HOSTS") [ -z "$DISTCC_HOSTS" ] || docker_env+=(-e "DISTCC_HOSTS=$DISTCC_HOSTS")
[ -z "${PRUNE_VIRTUALS}" ] || docker_env+=(-e "PRUNE_VIRTUALS=$PRUNE_VIRTUALS") [ -z "${PRUNE_VIRTUALS}" ] || docker_env+=(-e "PRUNE_VIRTUALS=$PRUNE_VIRTUALS")
[ -z "$REPOSITORY_NAME" ] || docker_env+=(-e "REPOSITORY_NAME=$REPOSITORY_NAME")
[ -z "$ENMAN_ADD_SELF" ] || docker_env+=(-e "ENMAN_ADD_SELF=$ENMAN_ADD_SELF")
[ -z "$EQUO_MASKS" ] || docker_env+=(-e "EQUO_MASKS=$EQUO_MASKS")
[ -z "$EQUO_UNMASKS" ] || docker_env+=(-e "EQUO_UNMASKS=$EQUO_UNMASKS")
if [ -n "$REMOTE_OVERLAY" ]; then if [ -n "$REMOTE_OVERLAY" ]; then
git clone "$REMOTE_OVERLAY" "$TEMPDIR" git clone "$REMOTE_OVERLAY" "$TEMPDIR"
@@ -56,7 +60,7 @@ function cleanup {
trap cleanup EXIT trap cleanup EXIT
[ -d "$LOCAL_OVERLAY" ] && docker_volumes+=(-v "$LOCAL_OVERLAY:/usr/local/portage") [ -d "$LOCAL_OVERLAY" ] && docker_volumes+=(-v "$LOCAL_OVERLAY:/usr/local/local_portage")
if [ -e $MAKE_CONF ]; then if [ -e $MAKE_CONF ]; then
echo "You specified a make.conf. I hope you know what are you doing" echo "You specified a make.conf. I hope you know what are you doing"
+8 -3
View File
@@ -54,19 +54,24 @@ mkdir -p /sabayon/artifacts
[[ -z "\${built_pkgs}" ]] && echo "ERROR: no tbz2s found" && exit 2 [[ -z "\${built_pkgs}" ]] && echo "ERROR: no tbz2s found" && exit 2
if [ -d "/sabayon/artifacts/standard" ]; then if [ -d "/sabayon/artifacts/standard" ]; then
echo "=== Repository already exists, syncronizing ==="
eit unlock \$repo || true eit unlock \$repo || true
eit pull --quick \$repo || true eit pull --quick \$repo || true
#eit sync \$repo #eit sync \$repo
else else
echo "=== Repository is empty, intializing ==="
echo "Yes" | eit init --quick \$repo echo "Yes" | eit init --quick \$repo
eit push --quick --force
fi fi
[ -f "/etc/entropy/mykeys/key.pub" ] && [ -f "/etc/entropy/mykeys/private.key" ] && { ! eit key status \$repo; } && \
eit key import \$repo /etc/entropy/mykeys/private.key /etc/entropy/mykeys/key.pub && { eit key sign \$repo || true; } && { echo "=== Repository key imported successfully ==="; }
echo "=== Injecting packages ==="
echo "Yes" | eit inject \${built_pkgs} || { echo "ouch unable to inject" && exit 3; } echo "Yes" | eit inject \${built_pkgs} || { echo "ouch unable to inject" && exit 3; }
echo "Yes Yes Yes" | eit commit --quick echo "Yes Yes Yes" | eit commit --quick
[ -f "/etc/entropy/mykeys/key.pub" ] && [ -f "/etc/entropy/mykeys/private.key" ] &&\ echo "=== Pushing built packages locally ==="
eit key import \$repo /etc/entropy/mykeys/private.key /etc/entropy/mykeys/key.pub && { eit key sign \$repo || true; }
eit push --quick --force eit push --quick --force
EOF EOF
+5
View File
@@ -25,6 +25,8 @@ docker_volumes=(
-v "$entropysrv:/etc/entropy/server.conf" -v "$entropysrv:/etc/entropy/server.conf"
-v "$PORTAGE_ARTIFACTS:/usr/portage/packages" ) -v "$PORTAGE_ARTIFACTS:/usr/portage/packages" )
[ -z "$PUBKEY" ] || docker_volumes+=(-v "$PUBKEY:/etc/entropy/mykeys/key.pub")
[ -z "$PRIVATEKEY" ] || docker_volumes+=(-v "$PRIVATEKEY:/etc/entropy/mykeys/private.key")
check_docker_requirements check_docker_requirements
@@ -46,6 +48,9 @@ else
echo "ouch no repository there" && exit 3; echo "ouch no repository there" && exit 3;
fi fi
[ -f "/etc/entropy/mykeys/key.pub" ] && [ -f "/etc/entropy/mykeys/private.key" ] && { ! eit key status \$repo; } && \
eit key import \$repo /etc/entropy/mykeys/private.key /etc/entropy/mykeys/key.pub && { eit key sign \$repo || true; } && { echo "=== Repository key imported successfully ==="; }
eit clean --quick || { echo "ouch unable to remove" && exit 3; } eit clean --quick || { echo "ouch unable to remove" && exit 3; }
eit vacuum --quick || { echo "ouch unable to remove" && exit 3; } eit vacuum --quick || { echo "ouch unable to remove" && exit 3; }
+5 -1
View File
@@ -24,7 +24,8 @@ docker_volumes=(
-v "$createrepo:/sabayon/bin/create_repo.sh" -v "$createrepo:/sabayon/bin/create_repo.sh"
-v "$entropysrv:/etc/entropy/server.conf" -v "$entropysrv:/etc/entropy/server.conf"
-v "$PORTAGE_ARTIFACTS:/usr/portage/packages" ) -v "$PORTAGE_ARTIFACTS:/usr/portage/packages" )
[ -z "$PUBKEY" ] || docker_volumes+=(-v "$PUBKEY:/etc/entropy/mykeys/key.pub")
[ -z "$PRIVATEKEY" ] || docker_volumes+=(-v "$PRIVATEKEY:/etc/entropy/mykeys/private.key")
check_docker_requirements check_docker_requirements
@@ -46,6 +47,9 @@ else
echo "ouch no repository there" && exit 3; echo "ouch no repository there" && exit 3;
fi fi
[ -f "/etc/entropy/mykeys/key.pub" ] && [ -f "/etc/entropy/mykeys/private.key" ] && { ! eit key status \$repo; } && \
eit key import \$repo /etc/entropy/mykeys/private.key /etc/entropy/mykeys/key.pub && { eit key sign \$repo || true; } && { echo "=== Repository key imported successfully ==="; }
echo "Yes" | eit rm --from \$repo ${args[@]} || { echo "ouch unable to remove" && exit 3; } echo "Yes" | eit rm --from \$repo ${args[@]} || { echo "ouch unable to remove" && exit 3; }
echo "Yes Yes Yes" | eit commit --quick echo "Yes Yes Yes" | eit commit --quick
eit push --quick --force eit push --quick --force
+6
View File
@@ -0,0 +1,6 @@
#!/bin/bash
sudo bash << EOF
echo "Grabbing system informations, the url to share will happear in a minute"
(echo 'lspci'; lspci; echo 'network'; ifconfig -a; echo 'drivers'; lsmod; find /lib/modules; echo 'kernel'; uname -a) | pastebunz
EOF
Regular → Executable
View File
Regular → Executable
View File
Regular → Executable
View File